﻿using System;
using log4net;
using Agent.Services;

namespace Agent.Models
{
    /// <summary>
    /// 사용자정보
    /// </summary>
    class User
    {
        private static readonly ILog log = LogManager.GetLogger(typeof(User));

        private readonly HashService _hashService = new HashService();

        public int Tid { get; set; }
        /// <summary>
        /// 사용자 아이디, 디스크시리얼(SHA256)
        /// </summary>
        public string Id { get; set; }
        /// <summary>
        /// 사용자 비밀번호(SHA256)
        /// </summary>
        public string Password { get; set; }
        /// <summary>
        /// 사용자 이름, NetBIOS
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 사용자 생성일시
        /// </summary>
        public DateTime Create_Date { get; set; }
        /// <summary>
        /// AD로그인 여부(사용안함)
        /// </summary>
        public bool Is_AD { get; set; }
        /// <summary>
        /// 시작프로그램 등록 여부
        /// </summary>
        public bool Is_Startup { get; set; }
        /// <summary>
        /// 실패시 재시도 여부
        /// </summary>
        public bool Is_Retry { get; set; }
        /// <summary>
        /// 대용량 일일 업로드 제한 여부
        /// </summary>
        public bool Is_Limit { get; set; }
        /// <summary>
        /// 중복 업로드 제한 여부
        /// </summary>
        public bool Is_Hash { get; set; }
        /// <summary>
        /// 백업주기(EVERY_DAY, EVERY_HOUR, REAL_TIME)
        /// </summary>
        public string Backup_type { get; set; }
        /// <summary>
        /// 사용자정의 태그1
        /// </summary>
        public string Tag1 { get; set; }
        /// <summary>
        /// 사용자정의 태그2
        /// </summary>
        public string Tag2 { get; set; }
        /// <summary>
        /// 사용자정의 태그3
        /// </summary>
        public string Tag3 { get; set; }
        /// <summary>
        /// 사용자정의 태그4
        /// </summary>
        public string Tag4 { get; set; }
        /// <summary>
        /// 사용자정의 태그5
        /// </summary>
        public string Tag5 { get; set; }
        /// <summary>
        /// 사용자정의 태그6
        /// </summary>
        public string Tag6 { get; set; }
        /// <summary>
        /// 사용자정의 태그7
        /// </summary>
        public string Tag7 { get; set; }
        /// <summary>
        /// 사용자정의 태그8
        /// </summary>
        public string Tag8 { get; set; }
        /// <summary>
        /// 사용자정의 태그9
        /// </summary>
        public string Tag9 { get; set; }
        /// <summary>
        /// 사용자정의 태그10
        /// </summary>
        public string Tag10 { get; set; }

        /// <summary>
        /// DI사용권한
        /// </summary>
        public string DI_Auth { get; set; }

        /// <summary>
        ///        /// <summary>
        /// 사용자ID  일치 여부(로그인시에만)
        /// </summary>
        public string IsMatchID(string userid)
        {
            string hash = _hashService.ToSHA256(userid);

            return hash;
        }
        /// 비밀번호 일치 여부(로그인시에만)
        /// </summary>
        public bool IsMatchPassword(string plain)
        {
            string hash = _hashService.ToSHA256(plain);

            return Password.Equals(hash);
        }

    }
}
