﻿using System.Windows.Forms;
using WpfWindow = System.Windows;
using System.Configuration;

namespace Agent.Services
{
    class TrayService
    {
        private readonly NotifyIcon _notifyIcon;

        private readonly string _programName = @ConfigurationManager.AppSettings["ProgramName"];

        public TrayService()
        {
            _notifyIcon = new NotifyIcon
            {
                Icon = Properties.Resources.tray,
                Text = _programName,
                Visible = false,
                ContextMenu = DefaultContextMenu()
            };

        }

        public NotifyIcon GetNotifyIcon()
        {
            return _notifyIcon;
        }

        public void DisposeNotifyIcon()
        {
            _notifyIcon.Dispose();
        }

        private ContextMenu DefaultContextMenu()
        {
            ContextMenu contextMenu = new ContextMenu();
            contextMenu.MenuItems.Add(CreateExitItem());

            return contextMenu;
        }

        private MenuItem CreateExitItem()
        {
            MenuItem exitItem = new MenuItem
            {
                Text = "종료"
            };

            exitItem.Click += ExitItem_Click;

            return exitItem;
        }

        private void ExitItem_Click(object sender, System.EventArgs e)
        {
            WpfWindow.Application.Current.Shutdown();
        }

    }
}
