﻿using System;
using System.Windows;
using System.Text;
using System.IO;
using System.Security.Cryptography;
using Agent.Services;
using Agent.Models;
using log4net;

namespace Agent.Views
{
    /// <summary>
    /// Interaction logic for LoginWindow.xaml
    /// </summary>
    public partial class LoginWindow : Window
    {
        private static readonly ILog log = LogManager.GetLogger(typeof(MainWindow));
        private readonly UserService _userService = new UserService();
        private readonly User _logincheck = new User();
        private readonly LoginWindow _loginWindowPage;

        public string ReturnValue1 = "";
        public string ReturnValue2 = "";

        public LoginWindow()
        {
            InitializeComponent();
        }

        public LoginWindow(LoginWindow loginWindow)
        {
            _loginWindowPage = loginWindow;
            InitializeComponent();
        }
        private void LoginButton_Click(object sender, RoutedEventArgs e)
        {
            string id, pw = "";

            //if (Public_Function.TimeLimitToPWD > 0 && end_time < DateTime.Now)
            //{
            //    Public_Function.AppendID = txt_ID.Text;

            //    MessageBox.Show("패스워드의 사용기한이 초과되었습니다.", "알림");
            //    Alter_PWD mAlter_PWD = new Alter_PWD();
            //    if (mAlter_PWD.f_ShowForm(txt_ID.Text, txt_Pass.Text))
            //        txt_Pass.Text = "";

            //    return;
            //}
            //else if (Public_Function.TimeLimitToPWD > 0 && end_time < DateTime.Now.AddDays(15))
            //{
            //    MessageBox.Show("패스워드 사용기한이 " + end_time.ToString("yyyy-MM-dd") + " 까지입니다. 패스워드를 변경하세요.!!!", "알림");
            //}

            #region<암호화>

            id = Encrypt(UserId.Text.Trim(), "ZR");
            pw = Encrypt(UserPassword.Password.Trim(), "ZR");

            //id = Encrypt_hanpoong("100", UserId.Text.Trim(), true);
            //pw = Encrypt_hanpoong("100", UserPassword.Password.Trim(), true);

            #endregion

            //var user1 = _logincheck.IsMatchID(UserId.Text);
            var user = _userService.LoginCheck(id);
            if (null == user || !user.Password.Equals(pw))
            //if (null == user || !user.IsMatchPassword(pw))
            {
                MessageBox.Show("아이디 또는 비밀번호가 일치하지 않습니다.", "오류", MessageBoxButton.OK, MessageBoxImage.Error);

                return;
            }

            if (user.DI_Auth == "N" || user.DI_Auth == null)
            {
                MessageBox.Show("DI 프로그램 사용권한이 없습니다.", "오류", MessageBoxButton.OK, MessageBoxImage.Error);

                return;
            }

            App._jobuserCd = UserId.Text.Trim();
            //_userService.SaveUserProperties(user);
            this.DialogResult = true;
            this.ReturnValue1 = UserId.Text.Trim();
            Close();
        }

        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private static int ord(char ch)
        {
            return (int)(Encoding.GetEncoding(1252).GetBytes(ch + "")[0]);
        }
        /**
         * Get character representation of ASCII Code
         *
         * @param int i ASCII code
         * @access private
         * @return char
         */
        private static char chr(int i)
        {
            byte[] bytes = new byte[1];
            bytes[0] = (byte)i;
            return Encoding.GetEncoding(1252).GetString(bytes)[0];
        }
        /**
		 * Convert Hex to Binary (hex2bin)
		 *
		 * @param string packtype Rudimentary in this implementation
		 * @param string datastring Hex to be packed into Binary
		 * @access private
		 * @return string
		 */
        private static string pack(string packtype, string datastring)
        {
            int i, j, datalength, packsize;
            byte[] bytes;
            char[] hex;
            string tmp;

            datalength = datastring.Length;
            packsize = (datalength / 2) + (datalength % 2);
            bytes = new byte[packsize];
            hex = new char[2];

            for (i = j = 0; i < datalength; i += 2)
            {
                hex[0] = datastring[i];
                if (datalength - i == 1)
                    hex[1] = '0';
                else
                    hex[1] = datastring[i + 1];
                tmp = new string(hex, 0, 2);
                try { bytes[j++] = byte.Parse(tmp, System.Globalization.NumberStyles.HexNumber); }
                catch { } /* grin */
            }
            return Encoding.GetEncoding(1252).GetString(bytes);
        }
        /**
         * Convert Binary to Hex (bin2hex)
         *
         * @param string bindata Binary data
         * @access public
         * @return string
         */
        public static string bin2hex(string bindata)
        {
            int i;
            byte[] bytes = Encoding.GetEncoding(1252).GetBytes(bindata);
            string hexString = "";
            for (i = 0; i < bytes.Length; i++)
            {
                hexString += bytes[i].ToString("x2");
            }
            return hexString;
        }
        public static byte[] Encrypt(byte[] clearData, byte[] Key, byte[] IV)
        {
        
            var ms = new MemoryStream();
            Rijndael alg = Rijndael.Create();
            alg.Key = Key;
            alg.IV = IV;
            var cs = new CryptoStream(ms, alg.CreateEncryptor(), CryptoStreamMode.Write);
        
            cs.Write(clearData, 0, clearData.Length);
            cs.Close();
            byte[] encryptedData = ms.ToArray();
        
            return encryptedData;
        }

        public static string Encrypt(string clearText, string Password)
        {
            byte[] clearBytes = Encoding.Unicode.GetBytes(clearText);
        
            var pdb = new PasswordDeriveBytes(Password, new byte[] {0x49, 0x76, 0x61, 0x6e, 0x20, 0x4d,
                                                0x65, 0x64, 0x76, 0x65, 0x64, 0x65, 0x76
                                                });
            byte[] encryptedData = Encrypt(clearBytes, pdb.GetBytes(32), pdb.GetBytes(16));
            return Convert.ToBase64String(encryptedData);
        }

        public static string Encrypt_hanpoong(string pwd, string data, bool ispwdHex)
        {
            int a, i, j, k, tmp, pwd_length, data_length;
            int[] key, box;
            byte[] cipher;
            //string cipher;

            if (ispwdHex)
                pwd = pack("H*", pwd); // valid input, please!
            pwd_length = pwd.Length;
            data_length = data.Length;
            key = new int[256];
            box = new int[256];
            cipher = new byte[data.Length];
            //cipher = "";

            for (i = 0; i < 256; i++)
            {
                key[i] = ord(pwd[i % pwd_length]);
                box[i] = i;
            }
            for (j = i = 0; i < 256; i++)
            {
                j = (j + box[i] + key[i]) % 256;
                tmp = box[i];
                box[i] = box[j];
                box[j] = tmp;
            }
            for (a = j = i = 0; i < data_length; i++)
            {
                a = (a + 1) % 256;
                j = (j + box[a]) % 256;
                tmp = box[a];
                box[a] = box[j];
                box[j] = tmp;
                k = box[((box[a] + box[j]) % 256)];
                cipher[i] = (byte)(ord(data[i]) ^ k);
                //cipher += chr(ord(data[i]) ^ k);
            }
            return Encoding.GetEncoding(1252).GetString(cipher);
            //return cipher;
        }
    }
}
