﻿using Agent.Services;
using log4net;
using System.Windows;
using WinForms = System.Windows.Forms;

namespace Agent.Views
{
    /// <summary>
    /// PolicySelectWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class PolicySelectWindow : Window
    {
        private static readonly ILog log = LogManager.GetLogger(typeof(PolicySelectWindow));

        private readonly PolicyService _policyService = new PolicyService();

        private readonly PolicyPage _policyPage;

        private PolicySelectWindow()
        {
        }

        public PolicySelectWindow(PolicyPage policyPage)
        {
            _policyPage = policyPage;
            InitializeComponent();
        }

       
        private void Folder_btn_Click(object sender, RoutedEventArgs e)
        {
            var frm1 = new LoginWindow();
            if (frm1.ShowDialog() == true)
            {
                var dialog = new WinForms.FolderBrowserDialog();

                if (dialog.ShowDialog() == WinForms.DialogResult.OK)
                {
                    if (!_policyService.AddDirectoryPolicy(dialog.SelectedPath, frm1.ReturnValue1))
                    {
                        MessageBox.Show("이미 경로가 중복되는 정책이 존재합니다.", "오류", MessageBoxButton.OK, MessageBoxImage.Error);

                        return;
                    }

                    _policyPage.FetchList();

                }
            }
            else
            {

            }
            Close();
        }

        private void File_btn_Click(object sender, RoutedEventArgs e)
        {
            var frm1 = new LoginWindow();
            if (frm1.ShowDialog() == true)
            {
                var dialog = new WinForms.OpenFileDialog
                {
                    Filter = "All files(*.*)|*.*"
                };

                if (dialog.ShowDialog() == WinForms.DialogResult.OK)
                {
                    if (!_policyService.AddFilePolicy(dialog.FileName,frm1.ReturnValue1))
                    {
                        MessageBox.Show("이미 경로가 중복되는 정책이 존재합니다.", "오류", MessageBoxButton.OK, MessageBoxImage.Error);

                        return;
                    }

                    _policyPage.FetchList();
                }
            }
            else
            {

            }
            Close();
        }
        
    }
}
