﻿using Agent.Models;
using Agent.Services;
using log4net;
using System.Configuration;
using System.Windows;

namespace Agent.Views
{
    /// <summary>
    /// PolicyTagWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class PolicyTagWindow : Window
    {
        private static readonly ILog log = LogManager.GetLogger(typeof(PolicyTagWindow));

        private readonly PolicyService _policyService = new PolicyService();

        private readonly PolicyPage _policyPage;

        private readonly PolicyListItem _selectedItem;

        private PolicyTagWindow()
        {
        }

        public PolicyTagWindow(PolicyPage policyPage, PolicyListItem selectedItem)
        {
            _policyPage = policyPage;
            _selectedItem = selectedItem;
            InitializeComponent();

            Tag1Header.Header = (string)Application.Current.Properties["user_tag1"];
            Tag2Header.Header = (string)Application.Current.Properties["user_tag2"];
            Tag3Header.Header = (string)Application.Current.Properties["user_tag3"];
            Tag4Header.Header = (string)Application.Current.Properties["user_tag4"];
            Tag5Header.Header = (string)Application.Current.Properties["user_tag5"];
            Tag6Header.Header = (string)Application.Current.Properties["user_tag6"];
            Tag7Header.Header = (string)Application.Current.Properties["user_tag7"];
            Tag8Header.Header = (string)Application.Current.Properties["user_tag8"];
            Tag9Header.Header = (string)Application.Current.Properties["user_tag9"];
            Tag10Header.Header = (string)Application.Current.Properties["user_tag10"];
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            PT_tag1_tb.Text = _selectedItem.Tag1;
            PT_tag2_tb.Text = _selectedItem.Tag2;
            PT_tag3_tb.Text = _selectedItem.Tag3;
            PT_tag4_tb.Text = _selectedItem.Tag4;
            PT_tag5_tb.Text = _selectedItem.Tag5;
            PT_tag6_tb.Text = _selectedItem.Tag6;
            PT_tag7_tb.Text = _selectedItem.Tag7;
            PT_tag8_tb.Text = _selectedItem.Tag8;
            PT_tag9_tb.Text = _selectedItem.Tag9;
            PT_tag10_tb.Text = _selectedItem.Tag10;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var result = MessageBox.Show("TAG를 적용하시겠습니까?", "확인", MessageBoxButton.YesNo, MessageBoxImage.Question);
            if (result == MessageBoxResult.No)
            {
                return;
            }

            _policyService.ModifyPolicyTags(
                _selectedItem.Tid,
                PT_tag1_tb.Text,
                PT_tag2_tb.Text,
                PT_tag3_tb.Text,
                PT_tag4_tb.Text,
                PT_tag5_tb.Text,
                PT_tag6_tb.Text,
                PT_tag7_tb.Text,
                PT_tag8_tb.Text,
                PT_tag9_tb.Text,
                PT_tag10_tb.Text
            );
            _policyPage.FetchList();

            Close();
        }
    }
}
